#Compile Dll
#Dim All
#Include "win32api.inc"

'---------------------------------------
'     Autotrax XP DirectX Video Driver
'---------------------------------------

'Version Record  autoxpdv.bas   www.airborn.com.au
'8  Nov  2004 Derived from existing work (Ref: AirCad) Credit Mark Smit, DirectX
'20 Nov  2004 Initial work and debug complete, about ready for Alpha version
'          Known Issues: We have no way of doing WMPAINT, the only way to redraw
'             screen is for the user to tap the "END" key (or other equivalent)
'             and that does not work when in menus anyway.
'          Moving or resizing our window can leave artifacts; scary but harmless
'          Our driver was NOT made to run more than one instance at a time
'          (The above issues don't matter when running Maximized as recommended)
'          The mouse only works if user selects "Hide Mouse Pointer" in titlebar
'          The cursor from the original NTVDM window still shows under our image
'1  June 2009 Fixed incorrect background colour assignment, search on 1/06/09
 

%AXCOL = 15                             'Number of autotrax colours we support

'---------------------------
'     DirectDraw Constants  
'---------------------------
%DD_OK                          = &H00000000
%DDSCL_FULLSCREEN               = &H00000001
%DDSCL_EXCLUSIVE                = &H00000010
%DDSCL_ALLOWMODEX               = &H00000040
%DDSCL_ALLOWREBOOT              = &H00000002
%DDSD_CAPS                      = &H00000001
%DDSD_BACKBUFFERCOUNT           = &H00000020
%DDSCAPS_COMPLEX                = &H00000008
%DDSCAPS_BACKBUFFER             = &H00000004    'Added 5 Nov 2004
%DDSCAPS_FLIP                   = &H00000010    'Added 5 Nov 2004
%DDSCAPS_PRIMARYSURFACE         = &H00000200    
%DDSCAPS_VIDEOMEMORY            = &H00004000    'Added 5 Nov 2004
%DDLOCK_SURFACEMEMORYPTR        = &H00000000
%DDLOCK_WAIT                    = &H00000001
 
 
'----------------------------
'     DirectDraw Interfaces  
'----------------------------
Type IDirectDraw
    '-- IUnknown methods --
    lpQueryInterface            As Long
    lpAddRef                    As Long
    lpRelease                   As Long
    '-- IDirectDraw methods --
    lpCompact                   As Long
    lpCreateClipper             As Long
    lpCreatePalette             As Long
    lpCreateSurface             As Long
    lpDuplicateSurface          As Long
    lpEnumDisplayModes          As Long
    lpEnumSurfaces              As Long
    lpFlipToGDISurface          As Long
    lpGetCaps                   As Long
    lpGetDisplayMode            As Long
    lpGetFourCCCodes            As Long
    lpGetGDISurface             As Long
    lpGetMonitorFequency        As Long
    lpGetScanLine               As Long
    lpGetVerticalBlankStatus    As Long
    lpInitialize                As Long
    lpRestoreDisplayMode        As Long
    lpSetCooperativeLevel       As Long
    lpSetDisplayMode            As Long
    lpWaitForVerticalBlank      As Long
End Type
 
 
Type IDirectDrawSurface
    '-- IUnknown methods --
    lpQueryInterface            As Long
    lpAddRef                    As Long
    lpRelease                   As Long
    '-- IDirectDrawSurface methods --
    lpAddAttachedSurface        As Long
    lpAddOverlayDirtyRect       As Long
    lpBlt                       As Long
    lpBltBatch                  As Long
    lpBltFast                   As Long
    lpDeleteAttachedSurface     As Long
    lpEnumAttachedSurfaces      As Long
    lpEnumOverlayZOrders        As Long
    lpFlip                      As Long
    lpGetAttachedSurface        As Long
    lpGetBltStatus              As Long
    lpGetCaps                   As Long
    lpGetClipper                As Long
    lpGetColorKey               As Long
    lpGetDC                     As Long
    lpGetFlipStatus             As Long
    lpGetOverlayPosition        As Long
    lpGetPalette                As Long
    lpGetPixelFormat            As Long
    lpGetSurfaceDesc            As Long
    lpInitialize                As Long
    lpIsLost                    As Long
    lpLock                      As Long
    lpReleaseDC                 As Long
    lpRestore                   As Long
    lpSetClipper                As Long
    lpSetColorKey               As Long
    lpSetOverlayPosition        As Long
    lpSetPalette                As Long
    lpUnlock                    As Long
    lpUpdateOverlay             As Long
    lpUpdateOverlayDisplay      As Long
    lpUpdateOverlayZOrder       As Long
End Type
 
  
'----------------------------
'     DirectDraw Structures  
'----------------------------
Type DDCOLORKEY
    dwColorSpaceLowValue    As Dword
    dwColorSpaceHighValue   As Dword
End Type
 
 
Type DDPIXELFORMAT
    dwSize              As Dword
    dwFlags             As Dword
    dwFourCC            As Dword
    dwRGBBitCount       As Dword       'RGB bits per pixel (4, 8, 16, 24, or 32)
    dwRBitDepth         As Dword
    dwGBitDepth         As Dword
    dwBBitDepth         As Dword
    dwRGBAlphaBitMask   As Dword
End Type
 
 
Type DDSCAPS
    dwCaps              As Dword
End Type
 
 
Type DDSURFACEDESC
    dwSize              As Dword
    dwFlags             As Dword
    dwHeight            As Dword
    dwWidth             As Dword
    lPitch              As Long
    dwBackBufferCount   As Dword
    dwRefreshRate       As Dword
    dwAlphaBitDepth     As Dword
    dwReserved          As Dword
    lpSurface           As Long
    ddckCKDestOverlay   As DDCOLORKEY
    ddckCKDestBlt       As DDCOLORKEY
    ddckCKSrcOverlay    As DDCOLORKEY
    ddckCKSrcBlt        As DDCOLORKEY
    ddpfPixelFormat     As DDPIXELFORMAT
    ddsCaps             As DDSCAPS
End Type
 
 
'-----------------------
'     Global Variables  
'-----------------------
Global hInst        As Long
Global lpDD         As IDirectDraw Ptr
Global lpSurface    As IDirectDrawSurface Ptr
Global ddsd         As DDSURFACEDESC  
Global PageWidth    As Long
Global PageHeight   As Long
Global PageBits     As Long
Global lpDisplay    As Long Ptr     'Display memory pointer
Global hLogFile     As Long         'File handles
                                                    
Global SurfWidth    As Dword    'Surface Width - one line (eg 1024)
Global SurflPitch   As Long     'Memory (in bytes) taken by one line
Global SurfHeight   As Dword    'Surface Height - (eg 768)
Global SurfRGBBitCount As Dword 'Bits per pixel - typically 32 or 24          
                                '  Want to add 16 bit colour to package, also
Global B1XMin       As Long     'One corner of main drawing box 
Global B1YMin       As Long
Global B1XMax       As Long     'Second corner of main drawing box
Global B1YMax       As Long
Global ScnClrCount  As Long
                                                    
Global Col()        As Long     'The colours used for each layer: 0 = Background

Global MyWindow     As Long     'Handle to our window (Foreground when init'ed)
Global MenuSp()     As Long     'Storage for screen menu space (Autotrax)
Global ClientArea   As Rect
Global WindowArea   As Rect  
Global DesktopArea  As Rect

'---------------------------
'     Function Definitions
'---------------------------
Declare Function DirectDrawCreate Lib "DDRAW.DLL" Alias "DirectDrawCreate" (ByVal Long,ByVal Long,ByVal Long) As Long


'-----------------------------------
'       NTVDM Function Definitions  
'-----------------------------------
Declare Function getAX Lib "ntvdm.exe" Alias "getAX"() As Long
Declare Function getBX Lib "ntvdm.exe" Alias "getBX"() As Long
Declare Function getCX Lib "ntvdm.exe" Alias "getCX"() As Long
Declare Function getDX Lib "ntvdm.exe" Alias "getDX"() As Long
Declare Function getSI Lib "ntvdm.exe" Alias "getSI"() As Long
Declare Function getDI Lib "ntvdm.exe" Alias "getDI"() As Long
Declare Function getBP Lib "ntvdm.exe" Alias "getBP"() As Long
'Declare Function getCS Lib "ntvdm.exe" Alias "getCS"() As Long  'These unneeded
'Declare Function getDS Lib "ntvdm.exe" Alias "getDS"() As Long
'Declare Function getES Lib "ntvdm.exe" Alias "getES"() As Long
'Declare Function getSS Lib "ntvdm.exe" Alias "getSS"() As Long
'Declare Function getIP Lib "ntvdm.exe" Alias "getIP"() As Long
'Declare Function getSP Lib "ntvdm.exe" Alias "getSP"() As Long
                                     
Declare Function setAX Lib "ntvdm.exe" Alias "setAX"(ByVal Long) As Long
'Declare Function setBX Lib "ntvdm.exe" Alias "setBX"(ByVal Long) As Long
'Declare Function setCX Lib "ntvdm.exe" Alias "setCX"(ByVal Long) As Long
'Declare Function setDX Lib "ntvdm.exe" Alias "setDX"(ByVal Long) As Long
'Declare Function setSI Lib "ntvdm.exe" Alias "setSI"(ByVal Long) As Long
'Declare Function setDI Lib "ntvdm.exe" Alias "setDI"(ByVal Long) As Long
'Declare Function setBP Lib "ntvdm.exe" Alias "setBP"(ByVal Long) As Long
'Declare Function setCS Lib "ntvdm.exe" Alias "setCS"(ByVal Long) As Long
'Declare Function setDS Lib "ntvdm.exe" Alias "setDS"(ByVal Long) As Long
'Declare Function setES Lib "ntvdm.exe" Alias "setES"(ByVal Long) As Long
'Declare Function setSS Lib "ntvdm.exe" Alias "setSS"(ByVal Long) As Long
'Declare Function setIP Lib "ntvdm.exe" Alias "setIP"(ByVal Long) As Long
'Declare Function setSP Lib "ntvdm.exe" Alias "setSP"(ByVal Long) As Long

 
'--------------------------
'     Interface Templates  
'--------------------------
Declare Function TSetDisplayMode (ByVal Long,ByVal Long,ByVal Long,ByVal Long) As Long
Declare Function TSetCooperativeLevel (ByVal Long,ByVal Long,ByVal Dword) As Long
Declare Function TCreateSurface (ByVal Long,ByVal Long,ByVal Long,ByVal Long) As Long
Declare Function TRestoreDisplayMode CDecl (ByVal Long) As Long
Declare Function TRelease (ByVal Long) As Long
Declare Function TLock (ByVal Long,Rect,ByVal Long,ByVal Dword,ByVal Long) As Long
Declare Function TUnlock (ByVal Long,Rect) As Long
Declare Function TGetAttachedSurface (ByVal Long,ByVal Long,ByVal Long) As Long 'Added 5 Nov
                                                            
Declare Function LogMessage(ByVal szMessage As String) As Long
 
 
'--------------------
'     Map Pallette
'--------------------
Function MakePal As Long
    Dim Col(0,47)                
                                'We altered DkRed,Blue,Red to add a bit of white
                                ' to stop them being so "primary" - looks better
                                '  and happens to better match original colours
    Col(0,16) = &H00000000    'Black
    Col(0,17) = &H00000080    'Dark Blue
    Col(0,18) = &H00008000    'Dark Green
    Col(0,19) = &H00008080    'Dark Cyan
    Col(0,20) = &H00803030    'Dark Red  was 800000
    Col(0,21) = &H00800080    'Dark Magenta
    Col(0,22) = &H00808000    'Dark YellowXX Brown
    Col(0,23) = &H00B0B0B0    'Light Grey 
    Col(0,24) = &H00808080    'Dark Grey
    Col(0,25) = &H004040FC    'Blue  was 0000FC
    Col(0,26) = &H0000FC00    'Green
    Col(0,27) = &H0000FCFC    'Cyan
    Col(0,28) = &H00FC4040    'Red   was FC0000
    Col(0,29) = &H00FC00FC    'Magenta
    Col(0,30) = &H00FCFC00    'Yellow
    Col(0,31) = &H00FCFCFC    'White

    Col(0,32) = &H00404040    'DarkDark Grey
    Col(0,33) = &H008080FC    'Medium Blue  
    Col(0,34) = &H0080FC80    'Medium Green 
    Col(0,35) = &H0080FCFC    'Medium Cyan  
    Col(0,36) = &H00FC8080    'Medium Red
    Col(0,37) = &H00FC80FC    'Medium Magenta
    Col(0,38) = &H00FCFC80    'Medium Yellow
    Col(0,39) = &H00FC8000    'Orange        
    Col(0,40) = &H00FCC080    'Medium Orange 
    Col(0,41) = &H00C0C0FC    'Light Blue  
    Col(0,42) = &H00C0FCC0    'Light Green 
    Col(0,43) = &H00C0FCFC    'Light Cyan  
    Col(0,44) = &H00FCC0C0    'Light Red      
    Col(0,45) = &H00FCC0FC    'Light Magenta
    Col(0,46) = &H00FCFCC0    'Light Yellow
    Col(0,47) = &H00FCE0C0    'Light Orange
                
    Col(0,0) = Col(0,23)    'Background = Light grey                                            
    Col(0,1) = Col(0,28)    'Top Layer = Red        
    Col(0,2) = Col(0,17)    'Mid Layer 1 = Dark Blue
    Col(0,3) = Col(0,18)    'Mid Layer 2 = Dark Green
    Col(0,4) = Col(0,19)    'Mid Layer 3 = Dark Cyan
    Col(0,5) = Col(0,20)    'Mid Layer 4 = Dark Red
    Col(0,6) = Col(0,25)    'Bottom Layer = Blue
    Col(0,7) = Col(0,30)    'Top overlay = Yellow
    Col(0,8) = Col(0,29)    'Bottom overlay = Magenta
    Col(0,9) = Col(0,25)    'Ground Plane = Blue
    Col(0,10)= Col(0,27)    'Power Plane = Cyan
    Col(0,11)= Col(0,22)    'Board Layer = Dark Yellow XXBrown
    Col(0,12)= Col(0,21)    'Keep Out Layer = Dark Magenta
    Col(0,13)= Col(0,20)    'Multilayer = Dark Red
    Col(0,14)= Col(0,31)    'Connections = White
    Col(0,15)= Col(0,31)    'Highlight = White
End Function


'--------------------
'     Open Log File
'--------------------
Function OpenLog As Long
    If hLogFile =0 Then                         'First test if the log is open
        hLogFile = FreeFile                         'Ask for a handle number
        Open"..\autotrax\AutoXPDv.log" For Output As hLogFile     'Open the file

        If Err Then                                 'Handle a file opening error
            hLogFile = 0
            Exit Function
        End If
    End If
    Function = %TRUE
End Function


'---------------------
'     Close Log File
'---------------------
Function CloseLog As Long
    If hLogFile Then
        Close hLogFile
        Function = %TRUE
    End If
End Function


'------------------
'     Log Message
'------------------
Function LogMessage(ByVal szMessage As String) As Long
    If hLogFile Then
        Print #hLogFile,szMessage
        Function = %TRUE
    End If
End Function


'------------------------------
'       Direct Draw Init
'------------------------------
Function InitDirectDraw(ByVal hWnd As Long) As Long
    Dim lResult As Long
 
 
    '-- Create DirectDraw Interface --
    lResult = DirectDrawCreate(%Null,ByVal VarPtr(lpDD),%Null)
    LogMessage"DirectDrawCreate: " & Format$(lResult)  
    LogMessage"DirectDrawInterface: " & Hex$(lpDD,8)
    
    '-- Set cooperative level --
    Call Dword @@lpDD.lpSetCooperativeLevel Using TSetCooperativeLevel(lpDD, _
        hWnd, %DDSCL_FULLSCREEN Or %DDSCL_ALLOWMODEX Or %DDSCL_EXCLUSIVE Or _
        %DDSCL_ALLOWREBOOT) To lResult  
    LogMessage"lpDD->SetCooperativeLevel: " & Format$(lResult)
 
    '-- Set display mode --
    Call Dword @@lpDD.lpSetDisplayMode Using TSetDisplayMode(lpDD,PageWidth, _
        PageHeight,PageBits) To lResult
    LogMessage"lpDD->SetDisplayMode: " & Format$(lResult)
 
    Reset ddsd
    ddsd.dwSize         = Len(ddsd)
    ddsd.dwFlags        = %DDSD_CAPS 
    ddsd.ddsCaps.dwCaps = %DDSCAPS_PRIMARYSURFACE 
    
    '-- Create primary surface --
    Call Dword @@lpDD.lpCreateSurface Using TCreateSurface(lpDD, _
        ByVal VarPtr(ddsd), ByVal VarPtr(lpSurface),%Null) To lResult
    LogMessage"lpDD->CreateSurface: " & Format$(lResult)

    Reset ddsd
    ddsd.dwSize = Len(ddsd)
 
    '-- Lock primary surface --
    Call Dword @@lpSurface.lpLock Using TLock (lpSurface,ByVal %Null,ByVal VarPtr(ddsd),%DDLOCK_SURFACEMEMORYPTR Or %DDLOCK_WAIT,%Null) To lResult
    LogMessage"lpSurface->Lock: " & Format$(lResult)
    LogMessage"ddsd.lpSurface: " & Hex$(ddsd.lpSurface,8)
                 
    SurfWidth  = ddsd.dwWidth
    SurflPitch = ddsd.lpitch 
    SurfHeight = ddsd.dwHeight             
    SurfRGBBitCount = ddsd.ddpfPixelFormat.dwRGBBitCount


    LogMessage"ReportedWidthValue: " & Format$(SurfWidth)
    LogMessage"ReportedHeightValue: " & Format$(SurfHeight)
    LogMessage"ReportedPitchValue: " & Format$(SurflPitch)
    LogMessage"dwRGBBitCount: " & Format$(SurfRGBBitCount)

    LogMessage"ddpfPixelFormat.dwFlags: " & Hex$(ddsd.ddpfPixelFormat.dwFlags,8)                                               
                                               
    lpDisplay = ddsd.lpSurface
    LogMessage"lpDisplay: " & Format$(lpDisplay)
 
    Function = %TRUE
End Function
 
 
'------------------------------------
'       Shutdown DirectDraw           
'------------------------------------
Function ShutdownDirectDraw As Long
    Dim lResult As Long
 
 
    If lpSurface Then
        '-- UnLock display surface --
        Call Dword @@lpSurface.lpUnlock Using TUnlock(lpSurface,ByVal %Null) To lResult
        LogMessage"lpSurface->Unlock: " & Format$(lResult)
 
        '-- Release DirectDraw surface --
        Call Dword @@lpSurface.lpRelease Using TRelease(lpSurface) To lResult
        LogMessage"lpSurface->Release: " & Format$(lResult)
    End If
 
    If lpDD Then
        '-- Release DirectDraw Interface --
        If lpDD Then
            Call Dword @@lpDD.lpRelease Using TRelease(lpDD) To lResult
            LogMessage"lpDD->Release: " & Format$(lResult)
        End If
    End If

    '-- Reset Pointer --
    lpDisplay = %Null
 
    Function = %TRUE
End Function
 

'------------------------------------
'       Autotrax Window Positioning
'------------------------------------
    Sub PositionW
        Local ClientOff As PointApi   
        Local B As Asciiz * 128

        GetClientRect(MyWindow,ClientArea)
        GetWindowRect(MyWindow,WindowArea)
        ClientOff.x = 0 :ClientOff.y = 0
        MapWindowPoints(MyWindow,%Null,ByRef ClientOff,1) 
                                                    '0,0 on client to desktop
        If lpDD = %Null Then 'Log message reporting only as initializing please
        LogMessage""
        LogMessage"Result of GetClientRect: " & Format$(ClientArea.nRight) _
                                      & " x " & Format$(ClientArea.nBottom)
        LogMessage"Result of GetWindowRect: " & Format$(WindowArea.nLeft) & _
           " x " & Format$(WindowArea.nRight) & " ; " _
                 & Format$(WindowArea.nTop)   & " x " _
                 & Format$(WindowArea.nBottom)
        LogMessage"MapWindowPoints: " + Format$(ClientOff.x) + " x " _
                 + Format$(ClientOff.y)
        End If
        If ClientArea.nRight+ClientArea.nBottom = 0 Then
            MsgBox "Sorry, the Driver fails if you set Window configuration to Full Screen",, _ 
                   "AutoXPDv.dll Unrecoverable Error"
        End If                                                                
        ClientArea.nRight = ClientArea.nRight + ClientOff.x
        ClientArea.nLeft  = ClientArea.nLeft  + ClientOff.x
        ClientArea.nTop   = ClientArea.nTop   + ClientOff.y
        ClientArea.nBottom= ClientArea.nBottom+ ClientOff.y
        If lpDD = %Null Then 'Log message reporting only as initializing please
        LogMessage"Real Client area, calculated: " & Format$(ClientArea.nLeft) _
            + " - " + Format$(ClientArea.nRight) + "  x  " _
            + Format$(ClientArea.nTop) + " - " + Format$(ClientArea.nBottom)
        End If
        Dialog Get Text MyWindow To B
       ' If Asc(B,40)=98 And Asc(B,45)=99 Then
        B1XMin = ClientArea.nLeft   'Set window clipping
        B1XMax = ClientArea.nRight  'Previously = PageWidth-10
        B1YMin = PageHeight - ClientArea.nBottom 'Previously =40
        B1YMax = PageHeight - ClientArea.nTop    'Previously = PageHeight-10 
       ' End If                                             
    End Sub


    Sub GrabMouse
    Local Who As Long
        If GetCapture()<>MyWindow Then  'Test: Do we have the mouse already? 
            SetCapture(MyWindow)        'Attempt to capture mouse to our window
            Who=GetCapture()            'Find out WHO has got the mouse
            If Who=MyWindow Then        'Test: Do we NOW have the mouse?
                LogMessage "We captured the mouse"
            Else                                  
                LogMessage "We missed capturing the mouse, mouse owned by: " _
                                        & Format$(Who)
            End If                            
        End If
    End Sub


'------------------------------------
'       Autotrax Interface Routines
'------------------------------------
    Sub WritePix(XPos As Long,YPos As Long,Colour As Long)
        Local DCol As Long

        If (YPos<(B1YMax-B1Ymin)) And _
                (Ypos > 0) And _
                (XPos > 0) And _
                (XPos < (B1XMax-B1XMin)) Then
            DCol = Col(0,(Colour And %AXCOL)+16)
            If (Colour And 32768)<>32768 Then
                @lpDisplay[B1XMin+XPos+((YPos+(SurfHeight-B1YMax)) _
                            *(SurflPitch\4))] = DCol
            Else
                @lpDisplay[B1XMin+XPos+((YPos+(SurfHeight-B1YMax)) *(SurflPitch\4))] = _
                @lpDisplay[B1XMin+XPos+((YPos+(SurfHeight-B1YMax)) *(SurflPitch\4))] Xor DCol
            End If
        End If
    End Sub


    Sub AxDisp Alias "AxDisp" () Export     'Here if called by 16 bit Autotrax
                                            'This routine is 16-->32 interface
        Local InBX As Long
        Local InCX As Long
        Local InDX As Long                          
        Local InSI As Long
        Local InDI As Long
        Local InBP As Long
        Local OutAX As Long
        Local XPos1 As Long
        Local XPos2 As Long
        Local XPos As Long      
        Local YPos1 As Long
        Local YPos2 As Long
        Local YPos As Long
        Local DCol As Long
                           
        InBX = getBX() And &H0FFFF          'Retrieve registers from 16 bit App
        InCX = getCX() And &H0FFFF                                                                      
        InDX = getDX() And &H0FFFF 
        InSI = getSI() And &H0FFFF
        InDI = getDI() And &H0FFFF
        InBP = getBP() And &H0FFFF                                                                      
        

        Select Case As Const InBX And 31    'Limit to significant bits
            Case 0                          'Get Driver type message from 16bit
                LogMessage"Get Driver Type Message seen"
                setAX(0)                    'Return to 16 bit App with AX=0
            Case 2                          'Horizontal line requested by 16bit
                                            'Process regs to draw the line    
                XPos1 = InCx:XPos2 = InSI: If XPos1>XPos2 Then Swap XPos1,XPos2
                                            'Assign Smaller X val to XPos1
                                            '    and larger X val to XPos2
                For XPos = XPos1 To XPos2   
                    WritePix(XPos,InDX,InBP) 'Write each pixel in the line
                Next XPos                    'Loop for the length of the line 
            Case 3                          'Vertical line
                YPos1 = InDX:YPos2 = InDI: If YPos1>YPos2 Then Swap YPos1,YPos2                
                For YPos = YPos1 To YPos2         
                    WritePix(InCX,YPos,InBP)
                Next YPos
            Case 6                          'Clear screen
                ScnClrCount = ScnClrCount+1
                PositionW                   'Find window position before clear
                DCol = Col(0,0)             'Colour to draw for clearscreen
                For YPos = ((SurfHeight-B1YMax) *(SurflPitch\4)) To _
                           ((SurfHeight-B1YMin) *(SurflPitch\4)) Step _
                                                        (SurflPitch\4) 
                    For XPos = YPos+B1XMin To YPos+B1XMax
                        @lpDisplay[XPos] = DCol
                    Next XPos
                Next YPos  
            Case 7                          'Graph mode 
            Case 11                         'Save menu
                If lpDisplay <> %Null Then
                For YPos = 0 To 199         'Scan the 200 line * 320 pix menu
                    For XPos = 0 To 319                                      
                        MenuSp(YPos,XPos)=@lpDisplay[B1XMin + XPos _
                            + ((YPos+(SurfHeight-B1YMax))*(SurflPitch\4))]
                    Next XPos
                Next YPos                 
                End If
            Case 12                         'Restore menu
                If lpDisplay <> %Null Then
                For YPos = 0 To 199         'Scan the 200 line * 320 pix menu
                    For XPos = 0 To 319                                      
                       @lpDisplay[B1XMin+XPos+((YPos+(SurfHeight-B1YMax))* _
                            (SurflPitch\4))] = MenuSp(YPos,XPos)    
                    Next XPos
                Next YPos                 
                End If
            Case 13                         'Max X size
                setAX(B1XMax-B1XMin)    
            Case 14                         'Max Y size
                setAX(B1YMax-(B1YMin+23))   'Magic numb 23 is statusline height                    
            Case 15                         'Number of colours
                setAX(%AXCOL)                
            Case 16                         'Number of background colours
                setAX(%AXCOL)                                     
            Case 17                         'Number of colour sets
                setAX(0)
            Case 18                         'Draw arrow cursor - Unimplemented                                
            Case 19                         'Set background colour
                DCol = InSI And %AXCOL      'DCol = Background colour
              ' Col(0,16) = Col(0,(DCol+16)) 'Incorrect bkgnd colour assign
                Col(0,0) = Col(0,(DCol+16)) 'Fixed 1/06/09 use correct index 0
            Case 20                         'Menu memory required
                setAX(0)
            Case 23                         'Any Graph mode setups
                If ScnClrCount <2 Then PositionW 'Window positioning takes a
                                            '  lot of CPU calls, but allows
                                            '  window to be moved with no
                                            '  artifacts, do only for new window
            Case 24                         'Any Graph mode takedowns
            Case 25                         'Set Pixel
                If (InDX<(B1YMax-(B1Ymin+23))) Then 'Magic value 23 is
                    WritePix(InCX,InDX,InSI)        '  statusline height
                End If
            Case 26                         'Set Pixel
                WritePix(InCX,InDX,InSI)
            Case Else
                LogMessage"Ax Dispatch, Func: " & Format$(InBX)

                LogMessage"  Registers seen, cx: " & Hex$(InCX) _
                                & "  dx: " & Hex$(InDX) _
                                & "  si: " & Hex$(InSI) _
                                & "  di: " & Hex$(InDI) _
                                & "  bp: " & Hex$(InBP)
        End Select
    End Sub


    Sub AxInit Alias "AxInit" () Export          
        Dim MenuSp(199,319) As Long   'Storage for screen menu
        Local temp As Long            
        Local temp2 As Long

        If MyWindow= 0 Then
            LogMessage"Autotrax init routine"
            MyWindow= GetForegroundWindow()
            Dialog Set Text MyWindow, _
                    "Autotrax with AutoXPDv driver - www.airborn.com.au"
            LogMessage"ForegroundWindow:       " + Format$(MyWindow)

            temp=GetWindowThreadProcessId(MyWindow, ByRef temp2)
            LogMessage"ProcessID ForegroundW:  " & Format$(temp2)
            LogMessage"ThreadID ForegroundWin: " & Format$(temp)

            temp = GetCurrentProcessId()
            LogMessage"OurCurrentProcessID is: " & Format$(temp)
            temp = GetCurrentThreadId()      'Checked - same as NTVDM.EXE
            LogMessage"OurCurrentThreadID is:  " & Format$(temp)

            SystemParametersInfo(%SPI_GETWORKAREA,0,DesktopArea,0)
            LogMessage"Reported size of Desktop: " _
                                    + Format$(DesktopArea.nLeft)  + " - " _
                                    + Format$(DesktopArea.nRight) + ", "  _
                                    + Format$(DesktopArea.nTop)   + " - " _
                                    + Format$(DesktopArea.nBottom)
            If Len(Dir$("..\autotrax\bigwindo.on",7))>0 Then
                Logmessage"  I saw the BigWindo.on file in \Autotrax"
            SetWindowPos(MyWindow,%HWND_TOP,DesktopArea.nLeft,DesktopArea.nTop, _
                DesktopArea.nRight  - DesktopArea.nLeft, _
                DesktopArea.nBottom - DesktopArea.nTop, _
                    (%SWP_NOSENDCHANGING))
            End If

            MakePal                 'Setup the colour pallette
            PageBits = 32           'Set PageBits to what we want: 32 bits
            PageWidth = GetSystemMetrics(%SM_CXSCREEN) 'Set page size to current
            PageHeight = GetSystemMetrics(%SM_CYSCREEN)
            LogMessage"Reported SM_CXSCREEN: " & Format$(PageWidth)
            LogMessage"Reported SM_CYSCREEN: " & Format$(PageHeight)
         End If
        'GrabMouse                   'Attempt to grab the mouse
        PositionW                   'Get window positioning based on client area
        If lpDD = %Null Then InitDirectDraw(MyWindow) 'Try and init DirectX
        If SurfRGBBitCount <> 32 Then
            MsgBox "Sorry, the Driver only supports 32 bit color, and your system is Set To " & _
                Format$(SurfRGBBitCount),, "AutoXPDv.dll Unrecoverable Error"
        End If                                                                
    End Sub

'---------------------------------
'       Main Entry Point for .DLL
'---------------------------------
Function LibMain(ByVal hInstance As Long, _
                 ByVal Reason    As Long, _
                 ByVal Reserved  As Long) _
                 Export As Long

    OpenLog                 'Open our error log for writing

    Select Case reason
        Case %DLL_PROCESS_ATTACH
            hInst = hInstance
    LogMessage "This logfile was created by Autoxpdv.dll and records info"
    LogMessage "  about how well we ran - or failed to run :-( "
    LogMessage "This file is temporary, overwritten, and can be deleted safely"
    LogMessage "This is autoxpdv.bas version AX090601"
    LogMessage ""
            LogMessage"%DLL_PROCESS_ATTACH"
            LogMessage"HInst Supplied to DLL is: " & Format$(hInst)
            LibMain = 1
            Exit Function
        Case %DLL_PROCESS_DETACH
            LogMessage"%DLL_PROCESS_DETACH"
            Exit Function
        Case %DLL_THREAD_ATTACH
            LogMessage"%DLL_THREAD_ATTACH"
            Exit Function
        Case %DLL_THREAD_DETACH
            LogMessage"%DLL_THREAD_DETACH"
            Exit Function
    End Select

    MsgBox "Windows Error in LIBMAIN()"     'We should never get here
    LibMain = 0                             'Failure
End Function
